function write(filename, dataObj, success, failure) {
	var dataObj = JSON.stringify(dataObj);
    dataObj = escape(dataObj);
	window.resolveLocalFileSystemURL(cordova.file.dataDirectory, function(dirEntry) {
	    dirEntry.getFile(filename, {create: true, exclusive: false}, function(fileEntry) {
	        writeFile(fileEntry, dataObj, success, failure);
	    }, failure);
	}, failure);
}

function writeFile(fileEntry, dataObj, success, failure) {
    // Create a FileWriter object for our FileEntry (log.txt).
    fileEntry.createWriter(function (fileWriter) {

        fileWriter.onwriteend = function() {
        	success && success();
        };

        fileWriter.onerror = function(e) {
            console.error("Failed file write: " + e.toString());
            failure && failure(e);
        };

        fileWriter.write(dataObj);
    });
}

function read(filename, success, failure) {
	window.resolveLocalFileSystemURL(cordova.file.dataDirectory, function(dir) {
		dir.getFile(filename, { create: true, exclusive: false}, function(fileEntry) {
			readFile(fileEntry, success, failure);
		});
	}, failure);
}

function readFile(fileEntry, success, failure) {

    fileEntry.file(function (file) {
        var reader = new FileReader();

        reader.onloadend = function() {
        	success(unescape(this.result));
        };

        //reader.readAsBinaryString(file);
        reader.readAsText(file,  'UTF-8');

    }, failure);
}

function checkIfFileExists(dirEntry, filename, fileExists, fileDoesNotExist) {
    window.resolveLocalFileSystemURL(dirEntry, 0, function(dirEntry) {
        dirEntry.getFile(filename, { create: false }, function(fileEntry) {
            fileExists(fileEntry.toURL());
        }, fileDoesNotExist);
    }, fileDoesNotExist);
}